program Project3;
{$APPTYPE CONSOLE}
uses
  SysUtils,
  Windows;


function LExpandFileName(const FileName: string): string;
var
  FName: PChar;                          // not used
  Buffer: array[0..1023] of Char;
begin
  SetString(Result, Buffer, GetFullPathName(PChar(FileName), SizeOf(Buffer),
    Buffer, FName));
end;


function LExtractFilePath(const FileName: string): string;
var
  I: Integer;
begin
  I := LastDelimiter('\:', FileName);    // find last occurrence of \ or :
  Result := Copy(FileName, 1, I);
end;


function LSetCurrentDir(const Dir: string): Boolean;
begin
  Result := SetCurrentDirectory(PChar(Dir));
end;


function LGetCurrentDir: string;
var
  Buffer: array[0..1023] of Char;
begin
  SetString(Result, Buffer, GetCurrentDirectory(SizeOf(Buffer), Buffer));
end;


const KILL:boolean=false;       // boolean flag used to signal ExexNewProcess


procedure ExecNewProcess(const ACommand, AParameters: String;
                         var result: integer);
var saSecurity:TSecurityAttributes;
    suiStartup:TStartupInfo;
     piProcess:TProcessInformation;
       Running:DWord;
 begin

   result:=-($DEAD);           // default exit code if unable to complete

   FillChar(saSecurity, SizeOf(TSecurityAttributes), #0);
   saSecurity.nLength:=SizeOf(TSecurityAttributes);
   saSecurity.bInheritHandle:=true;
   saSecurity.lpSecurityDescriptor:=nil;

   begin
     FillChar(suiStartup, SizeOf(TStartupInfo), #0);
     suiStartup.cb:=SizeOf(TStartupInfo);
//   suiStartup.dwFlags:=STARTF_USESTDHANDLES or STARTF_USESHOWWINDOW;
//   suiStartup.wShowWindow:=SW_HIDE;

     if CreateProcess(nil, PChar(ACommand + ' ' + AParameters),
                      @saSecurity, @saSecurity, True, NORMAL_PRIORITY_CLASS,
                      nil, nil, suiStartup, piProcess) then
     begin
       repeat
         Running:=WaitForSingleObject(piProcess.hProcess, 100);
//       Application.ProcessMessages();
       until (Running<>WAIT_TIMEOUT) (* or DONE or KILL *);

       GetExitCodeProcess(piProcess.hProcess, DWORD(result));
       if KILL then TerminateProcess(piProcess.hProcess, 0);

       try CloseHandle(piProcess.hProcess) except end;
       try CloseHandle(piProcess.hThread) except end
     end
   end
end;



var result:integer;

begin
  SetConsoleTitle('Win32 MMBasic');

  if paramcount=1 then
  begin
    writeln(LGetCurrentDir);                        // this may end up being wrong
    writeln;
//  writeln(LExtractFilePath(paramstr(1)));         // path portion of argv[1]
//  writeln('>> ',paramstr(1));                     // argv[1]
//  writeln('>> ',LExpandFileName(paramstr(1)));    // ... expanded to an absolute path
//  writeln('>> ',LExtractFilePath(LExpandFileName(paramstr(1))));   // ... path extracted

    LSetCurrentDir(LExtractFilePath(LExpandFileName(paramstr(1))));
    writeln(LGetCurrentDir);                        // check we set it correctly
    writeln;

    writeln(paramstr(1));
    writeln;

    ExecNewProcess('MMBasic.exe', '"'+Paramstr(1)+'"', result)

  end else
    messagebox(0, '    Drop your basic program    '+#13+
                  '    onto the icon to run it    '+#13+
                  '    with MMBasic    ',
                  'Information', MB_OK+MB_ICONINFORMATION)

end.




